//General Tracking experiment

//**********************Waveform Analysis***********************
import ddf.minim.spi.*;
import ddf.minim.signals.*;
import ddf.minim.*;
import ddf.minim.analysis.*;
import ddf.minim.ugens.*;
import ddf.minim.effects.*;

//*******************GUI*********************
import controlP5.*;

ControlP5 cp5;            //This sets up all the GUI interactions
DropdownList menu1, menu2, menu3, menu4, menu5, menu6, menu7;
int theMenu, theVal;
Button stopButton, goButton, oldButton;
CColor stopColor, goColor, oldColor;
Slider abc;

float slVis = 5;
float slBlank = 0;
//******************
Minim minim;
FFT myfft;

PFont font;

//******************

//Other classes
//
Vnoise dN, dV;               //Different kinds of noise source
//PController pCtl, aCtl;     //different controllers that use different perceptual functions
//PFunction pF, pFa;          //different perceptual functions
dataGraph fr, gr, hr;       //Frames for data graphs
//
//******************

//Global Variables
//target parameters
int targ_v, targ_h, targ_w, targ_t;
//Cursor parameters
int curs_v, curs_h, curs_w, curs_t;
int tOffset, cOffset;
// File variables
String dataFolderR, dataFolderW;
char tType;
boolean newRun, modelData, recording, folderChosen;
int lat, sv, dType, sep, sepRange, sdif, bbVal;
int lcy, hcy;
int blankingPeriod;
int blankTime, visTime, tBlankTime, tVisTime, slVar, tVar, tFrame;
int blankVar, burstVar;
int cursorBlank;       // 1 if cursor is visible, 0 if not
boolean isBlanking, isBursting, bbIsVariable;
float perlinRate, sVal;
float L10;
int stage, runin, actLag, mCount, mInit;
int frestart, fstart, fnow, msecStart, msecNow, frecStart;
float[] distF = new float[6000];
float[] distV = new float[6000];
int[][] data = new int[12][6000];
int[] mxBuf = new int[1000];            //ring buffer allows action delays in units of one frame time
int[] stills = new int[4400];         // crude array to get stillstand durations
int[] cumStills = new int[4400];
float mean_t, mean_c, mean_e, mean_s;
float rms_t, rms_c, rms_e, rms_s, rms_a;
String myFile, myFileBase, inFile;
File f, folder;


//********************

void setup() {
  size(1100, 900);
  minim = new Minim(this);        //Needed for the Fourier transform analysis
  L10 = 1/log(10);                 // A useful constant
  setMenus();
  setDefaults();
}

void setMenus() {
  // Task property Menus
  cp5 = new ControlP5(this);
  menu1 = cp5.addDropdownList("Difficulty").setPosition(140, 40)
    .setItemHeight(20)
      .setBarHeight(20)
        .setSize(100, 120)
          .setVisible(false);
  for (int i = 0; i < 5; i++) {
    menu1.addItem("Difficulty " + (i+1), i+1);
  }
  menu2 = cp5.addDropdownList("Separation").setPosition(250, 40)
    .setItemHeight(20)
      .setBarHeight(20)
        .setSize(100, 200)
          .setVisible(false);  
  for (int i = 0; i < 9; i++) {
    switch (i) {
    case 0:
      menu2.addItem("Separation "+ 0, 0);
      break;
    case 1:
      menu2.addItem("Separation "+ 25, 1);
      break;
    case 2:
      menu2.addItem("Separation "+ 70, 2);
      break;
    case 3:
      menu2.addItem("Separation "+ 180, 3);
      break;
    case 4:
      menu2.addItem("Separation "+ 410, 4);
      break;
    case 5: 
      menu2.addItem("Separation "+ 980, 5);
      break;
    case 6:
      menu2.addItem("Random slow-narrow", 6);
      break;
    case 7:
      menu2.addItem("Random slow-wide", 7);
      break;    
    case 8:
      menu2.addItem("Random fast-wide", 8);
      break;    
    default:
      break;
    }
  }
  menu3 = cp5.addDropdownList("Data Folder").setPosition(900, 40)
    .setItemHeight(20)
      .setBarHeight(20)
        .setSize(100, 80)
          .setVisible(false);
  menu3.addItem("Default", 0);
  menu3.addItem("Choose Folder File", 1);

  menu4 = cp5.addDropdownList("Disturbance Type").setPosition(30, 40)
    .setItemHeight(20)
      .setBarHeight(20)
        .setSize(100, 200)
          .setVisible(false);
  for (int i = 0; i< 8; i++) {
    switch (i) {
    case 0:
      menu4.addItem("Smooth", 0);
      break;
    case 1:
      menu4.addItem("Ramp", 1);
      break;
    case 2:
      menu4.addItem("VariableTriangle", 2);
      break;
    case 3:
      menu4.addItem("RandomStep", 3);
      break;
    case 4:
      menu4.addItem("Triangle", 4);
      break;
    case 5: 
      menu4.addItem("Perlin", 5);
      break;
    case 6: 
      menu4.addItem("SmallStep", 6);
      break;
    case 7: 
      menu4.addItem("White", 7);
      break;
    default:
      break;
    }
  }

  menu5 = cp5.addDropdownList("Action Lag").setPosition(360, 40)
    .setItemHeight(20)
      .setBarHeight(20)
        .setSize(100, 200)
          .setVisible(false);
  for (int i = 0; i< 9; i++) {
    switch (i) {
    case 0:
      menu5.addItem("Zero", 0);
      break;
    case 1:
      menu5.addItem("50 msec", 3);       //3 frames
      break;
    case 2:
      menu5.addItem("100 msec", 6);      //6 Frames
      break;
    case 3:
      menu5.addItem("200 msec", 12);      //12 Frames
      break;
    case 4:
      menu5.addItem("300 msec", 18);       //24 Frames
      break;
    case 5:
      menu5.addItem("400 msec", 24);       //48 Frames
      break;
    case 6:
      menu5.addItem("500 msec", 30);       //48 Frames
      break;
    case 7:
      menu5.addItem("600 msec", 36);       //48 Frames
      break;
    default:
      break;
    }
  }

  menu6 = cp5.addDropdownList("Tracking Type").setPosition(470, 40)
    .setItemHeight(20)
      .setBarHeight(20)
        .setSize(100, 80)
          .setVisible(false);
  for (int i = 0; i< 3; i++) {
    switch (i) {
    case 0:
      menu6.addItem("Pursuit", 0);
      break;
    case 1:
      menu6.addItem("Compensatory", 1);       //3 frames
      break;
    default:
      break;
    }
  }

  menu7 = cp5.addDropdownList("Blanking/Bursting").setPosition(580, 40)
    .setItemHeight(20)
      .setBarHeight(20)
        .setSize(100, 160)
          .setVisible(false);
  for (int i = 0; i< 5; i++) {
    switch (i) {
    case 0:
      menu7.addItem("None", 0);
      break;
    case 1:
      menu7.addItem("Blanking", 1);       //Set blanking and visible periods
      break;
    case 2:
      menu7.addItem("Bursting", 2);       //set Bursting and static periods     
      break;
    case 3:
      menu7.addItem("Irregular Blanking", 3);       //set Bursting and static periods     
      break;
    case 4:
      menu7.addItem("Irregular Bursting", 4);       //set Bursting and static periods     
      break;
    default:
      break;
    }
  }

  cp5.addSlider("slVis")
    .setPosition(580, 145)
      .setSize(120, 20)
        .setRange(0, 20)
          .setSliderMode(Slider.FLEXIBLE)
            .setNumberOfTickMarks(21)
              .showTickMarks(false)
                .setVisible(false)
                  .setLabel("Visible Interval Seconds");
  ;

  cp5.addSlider("slBlank")
    .setPosition(580, 120)
      .setSize(120, 20)
        .setRange(0, 10)
          .setSliderMode(Slider.FLEXIBLE)
            .setNumberOfTickMarks(21)
              .showTickMarks(false)
                .setVisible(false)
                  .setLabel("Blanking Interval Seconds");
  ;

  cp5.addSlider("slVar")
    .setPosition(580, 160)
      .setSize(120, 20)
        .setRange(0, 100)
          .setSliderMode(Slider.FLEXIBLE)
            .setNumberOfTickMarks(11)
              .showTickMarks(false)
                .setVisible(false)
                  .setLabel("Blanking Variability");
  ;

  cp5.addSlider("lcy")
    .setPosition(140, 180)
      .setSize(120, 20)
        .setRange(0, 30)
          .setSliderMode(Slider.FLEXIBLE)
            .setNumberOfTickMarks(11)
              .showTickMarks(false)
                .setVisible(false)
                  .setLabel("Low Bound");
  ;


  // Buttons
  stopColor = new CColor(#ff0033, #996633, #9933FF, 128, 255);
  stopButton = cp5.addButton("Abort")
    .setPosition(width - 40, 20)
      .setSize(30, 20)
        .setColor(stopColor);
  goColor = new CColor(#33ff33, #33cc99, #EE6633, 128, 255);
  goButton = cp5.addButton("Go")
    .setPosition(width - 80, 20)
      .setColor(goColor)
        .setSize(30, 20)
          .setSwitch(true)
            .setOff();
}


void setDefaults() {
  tType = 'p';
  targ_h = width/2;
  tOffset = width/2;
  curs_h = width/2;
  curs_w = 10;
  targ_w = 10;
  curs_t = 20;
  targ_t = 20;
  dType = 0;         //Set disturbance type to be "Smooth"
  sVal = 3;         //pink noise, rate 2
  lat = 180;
  sv = 0;            // sv defines speed and range of vertical separation noise; default is use "lat"
  sep = 3;     //code number for separation type set from separation menu
  runin = 300;       //300 frames= 5 seconds runin time
  frameRate(60);
  dataFolderR = "";
  dataFolderW = "data/";
  hint(ENABLE_NATIVE_FONTS);
  String[] fonts = font.list();
  println(fonts);
  font = createFont("Helvetica", 32, true);
  textFont(font, 32);
  newRun = true;
  modelData = false;
  isBlanking = false;
  isBursting = false;
  bbIsVariable = false;
  tVar = 0;
  stage = 0;
}


void draw() {
  switch (stage) {
  case 0:                   //Display instructions
    stage_0();
    break;
  case 1:                     //set configuration of experiment
    stage_1();
    break;
  case 2:                     //practice tracking
    stage_2();
    checkMouseEdge();
    break;
  case 3:                     //record data
    stage_3();
    checkMouseEdge();    
    break;
  case 4:                     // prepare to analyze new data
    stage_4();
    break;
  case 5:                     //fit control model
    stage_5();
    break;
  case 6:                     //save data
    stage_6();
    break;
  case 7:                     //show tracking graph
    stage_7();
    break;
  default:
    break;
  }   

  if (stage >1 && stage < 4) {
  if ((isBlanking == true) || (isBursting == true)){
  if (frameCount%blankingPeriod == 0) {  
//print("Resetting, bbIsVariable = "+ bbIsVariable);
    if (bbIsVariable == false) {
      tBlankTime = blankTime;
      tVisTime = visTime;
    } 
    else {
      tBlankTime = blankTime +round(tVar*(random(2) -1)*blankTime/100);
      tVisTime = visTime + round(tVar*(random(2) -1)*visTime/100);
//println("New blank time = "+tBlankTime+" vis time = "+tVisTime);
    }
    blankingPeriod = tBlankTime+tVisTime;
  }
  }
    if (isBlanking == true) {
      if (tType == 'c') {            //For compensatory tracking, blank the cursor
        cursorBlank = 1;
        drawTarget();
        if (blankTime == 0) {
          drawCursor();
        } 
        else {
          if (frameCount%blankingPeriod < tVisTime) {
            drawCursor();
          } 
          else {
            cursorBlank = 0;
          }
        }
      } 
      else {             // for pursuit tracking, blank the target
        cursorBlank = 1;
        drawCursor();
        if (blankTime == 0) {
          drawTarget();
        } 
        else {
          if (frameCount%blankingPeriod < tVisTime) {
            drawTarget();
          } 
          else {
            cursorBlank = 0;
          }
        }
      }


      //  println("Visible = "+slVis+", Blanked = "+slBlank);
    }
    else {

      drawTarget();
      drawCursor();
    }
  }
}  //end draw()

//*****************************************************************************
//***************Experiment stages*********************************************

//************Stage 0: Present Instructions

void stage_0() {
  stage = 1;
}

//*******Stage 1: Let experimenter choose what to do

void stage_1() {                 //set experiment parameters
  background(#664422);
  frestart = frameCount;
  fstart = frameCount;
  menu1.setVisible(true);
  menu2.setVisible(true);
  menu3.setVisible(true);
  menu4.setVisible(true);
  menu5.setVisible(true);
  menu6.setVisible(true);
  menu7.setVisible(true);
  switch (bbVal) {
  case 0:
    cp5.getController("slBlank").setVisible(false);
    cp5.getController("slVis").setVisible(false);
    cp5.getController("slVar").setVisible(false);
    break;
  case 1:
    cp5.getController("slVis").setCaptionLabel("Visible time secs.");
    cp5.getController("slBlank").setCaptionLabel("Blanking time secs.");
    cp5.getController("slVis").setVisible(true);
    cp5.getController("slBlank").setVisible(true);
    isBlanking = true;
    isBursting = false;
    bbIsVariable = false;
    slVar = 0;
    break;
  case 2:
    cp5.getController("slVis").setCaptionLabel("Burst time secs.");
    cp5.getController("slBlank").setCaptionLabel("Static time secs.");
    cp5.getController("slVis").setVisible(true);
    cp5.getController("slBlank").setVisible(true);
    isBlanking = false;
    isBursting = true;
    bbIsVariable = false;
    slVar = 0;
    break;
  case 3:
    cp5.getController("slVis").setCaptionLabel("Mean Visible time secs.");
    cp5.getController("slBlank").setCaptionLabel("Mean Blanking time secs.");
    cp5.getController("slVar").setCaptionLabel("Variability %");    
    cp5.getController("slVis").setVisible(true);
    cp5.getController("slBlank").setVisible(true);
    cp5.getController("slVar").setVisible(true);
    isBlanking = true;
    isBursting = false;
    bbIsVariable = true;
    break;
  case 4:
    cp5.getController("slVis").setCaptionLabel("Mean Burst time secs.");
    cp5.getController("slBlank").setCaptionLabel("Mean Static time secs.");
    cp5.getController("slVar").setCaptionLabel("Variability %");    
    cp5.getController("slVis").setVisible(true);
    cp5.getController("slBlank").setVisible(true);
    cp5.getController("slVar").setVisible(true);
    isBlanking = false;
    isBursting = true;
    bbIsVariable = true;
    break;
  }

  goButton.setVisible(true);
  stopButton.setVisible(true);
  blankTime = round(frameRate*slBlank);
  visTime = round(frameRate*slVis);
  tVar = slVar;
  if (blankTime == 0) {
    isBlanking = false;
    isBursting = false;
  }
  blankingPeriod = blankTime+visTime;
//println("isBlanking, isBursting = "+isBlanking+" "+isBursting+", slVar = "+slVar);
  targ_v = height/2 - lat/2 - round(curs_t + targ_t)/2;
  curs_v = targ_v + round(curs_t + targ_t)/2 + lat;
  //  menu4.setVisible(true);
  //  if (oldButton.isOn()) {           //Select an existing file to analyze
  //    //    println("OldButton was pressed");
  //    oldButton.setOff();
  //    selectInput("Choose File to Process", "doFile");
  //  }

  switch (sv) {         //Set vertical separation
  case 0:               //Fixed vertical
    sepRange = 0;
    perlinRate = 0;
    break;
  case 1:     //narrow slow variation
    sepRange = 100;
    perlinRate = .003;
    lat = 10;
    break;
  case 2:     //Wide slow
    sepRange = 400;
    perlinRate = .003;
    lat = 20;
    break;
  case 3:     //wide fast
    sepRange = 400;
    perlinRate = .01;
    lat = 20;
    break;
  default:
    println("unknown separation type "+sv);
  }
  
  if (dType == 7) {   //get the bandpass boundaries
     cp5.getController("lcy").setVisible(true);
  }
    
  if (goButton.isOn()) {            //Go button is pressed after menu selections are complete
    newRun = true;
    menu1.setVisible(false);
    menu2.setVisible(false);
    menu3.setVisible(false);
    menu4.setVisible(false);
    menu5.setVisible(false);
    menu6.setVisible(false);
    menu7.setVisible(false);
    cp5.getController("slVis").setVisible(false);
    cp5.getController("slBlank").setVisible(false);
    cp5.getController("slVar").setVisible(false);
    cp5.getController("lcy").setVisible(false);
    //    oldButton.setVisible(false);
    goButton.setVisible(false);
    // get the desired kind of noise for the disturbance
    //first make it using selected parameters of the experiment
    //then get what was made

      switch (dType) {         // dTyoe is set in controlEvent()
    case 0:
      dN = new Vnoise(6000, "Smooth", sVal);
      distF = dN.getVnoise();
      break;
    case 1:
      dN = new Vnoise(6000, "Ramp", sVal);
      distF = dN.getVnoise();
      break;
    case 2:
      dN = new Vnoise(6000, "VariableTriangle", sVal);
      distF = dN.getVnoise();
      break;
    case 3:
      dN = new Vnoise(6000, "RandomStep", sVal);
      distF = dN.getVnoise();
      break;
    case 4:
      dN = new Vnoise(6000, "Triangle", sVal);
      distF = dN.getVnoise();
      break;
    case 5:
      dN = new Vnoise(6000, "Perlin", sVal);
      distF = dN.getVnoise();
      break;
    case 6:
      dN = new Vnoise(6000, "SmallStep", sVal);
      distF = dN.getVnoise();
      break;
    case 7:
      dN = new Vnoise(6000, "White", sVal, lcy);
      distF = dN.getVnoise();
      break;
    default:
      println ("disturbance type unknown");
    }

    //*****************************

    //Get the experiment going
    recording = true;           // We now record the 300 sample runin so that any model can start the
    //analyzwed portion of the run in the same way the human does
    fstart = frameCount+1;      // used for continuous sampling of the noise array 
    fnow = frameCount+1;       //("+1" allows for one frame before this is used
    curs_h = targ_h;
    msecStart = millis()+round(1000/frameRate);
    mCount = 0;
    frecStart = frameCount+1;
    tFrame = 0;                  //tFrame will be the index into the noise distribution
    stage = 2;
  }
}

//Preliminary run-in

void stage_2() {
  if (frameCount - fnow <= runin) {
    background(#554433);
    tracking(tType);
  } 
  else {                           //runin is over. Now start the recording
    recording = true;
    msecNow=millis()-msecStart;
    msecStart = millis();
    fnow = frameCount+1;
    stage = 3;
  }
}


//***********Start data collection for 4096 frames = 68.25 seconds
//***********A popwer of 2 number of frames eases any later Fourier analysis

void stage_3() {                  // Data collection.
  background (#334455);
  tracking(tType);
  if (frameCount-fnow>=4096) {  //Must be a power of 2 number of frames for FFT
    msecNow=millis()-msecStart;
    msecStart = millis()+round(1000/frameRate);
    fnow = frameCount+1;
    goButton.setOff();
    stage = 4;
  }
}

//**********************Display the part of the run that will be analyzed**************
//*****************************and save it in a file*******************************

void stage_4() {      //Draw graphs based directly on data
  goButton.setOff();
  gr = new dataGraph(100, 50, width-200, 250, #332244);
  gr.grBackground(data[5], 4096, 303, #443355);
  mean_t = getMean(data[0], 4096, 303);   //Start display only after the runin portion
  mean_c = getMean(data[1], 4096, 303);
  mean_e = getMean(data[2], 4096, 303);
  mean_s = getMean(data[3], 4096, 303);
  int gwd = round(gr.getGheight()/2);
  gr.graphData(data[0], 4096, 303, #EE3333, 0.25, mean_t, gwd);      //Target  red
  gr.grLabel(#EE3333, "disturbance influence", 1);
  gr.graphData(data[1], 4096, 303, #33FF22, 0.25, mean_t, gwd);      //Human cursor  green
  gr.grLabel(#33FF22, "output influence", 2);
  gr.graphData(data[2], 4096, 303, #EEEE33, 0.25, 0, gwd);          //Human error  yellow
  gr.grLabel(#EEEE33, "error", 3);
  if (sv > 0) {
    gr.graphData(data[3], 4096, 303, #3399bb, 0.25, mean_s, gwd);    //Separation track off-white
    gr.grLabel(#999933, "variation of target-cursor separation", 4);
  }
  gr.grxDivisions(60, 10, "Seconds", true, 4096);
  gr.gryDivisions(5, 5, "100 Pixels Major Division");
  gr.grTitle("Traces", 16, 10, 30, #EEEE33);

  // Create distribution of still-stand durations and graph it
  for (int i = 0; i < stills.length; i++) {
    stills[i] = 0;
  }
  int sj = 0;
  for (int i = 303; i <4400; i++) {
    if (data[1][i] == data[1][i-1]) {
      sj++;
    }
    else {
      if (sj > 0) {
        stills[sj]++;
      }
      sj = 0;
    }
  }      // stills now has the number of times a still stand lasted j frames in its jth element

  int j = 0;
  int stMax = 0;
  for (int i = 0; i < stills.length; i++) {
    j += stills[i];
    cumStills[i] = j;           //cumStills cumulates Stills
    if (stills[i] != 0) {
      stMax = i;                // i is the length in frames of the longest stillstand
    }
  }

  int still80 = round(cumStills[stMax]*0.9);
  int still_80 = 12345;

  for (int i = 0; cumStills[i] < still80; i++) {
    still_80 = i;        //When the loop ends, still_80 will hold the 90th percepntile frame
  }
  // still_80 is the index of the frame before the 90th, so interpolate to get a better measure

  float st_80, cst_80;

  cst_80 = cumStills[stMax]*.9;

  st_80 = still_80 + (cst_80 - cumStills[still_80])/(cumStills[1+still_80]-cumStills[still_80]);
  st_80 = round(100*st_80);
  st_80 /= 100;              //To get 2 digits after the decimal

  //plot cumulative histogram
  dataGraph h = new dataGraph(100, 375, 400, 200, 50);  //A background for the cumulative historgram
  float hsc =  float(200)/cumStills[stMax];         // scale data to fit graph
  h.graphData(cumStills, 40, 0, #CCCC33, hsc);
  h.grxDivisions(10, 5, "Frames", true);
  h.gryDivisions(40, 5, "Percentile");
  h.grTitle("Cumulative Dwell times", 16, 380, 35, #cccc00, RIGHT);
  String hlab =  "90th percentile dwell time "+st_80+" frames";
  h.grResults(#CCCC33, hlab, 1, 0);
  stage = 5;
}

void stage_5() {     //Soem preliminary analysis
  //Fourier analysis first
  float[] fRange = new float[2];
  float[][] fError = new float[15][1024];
  float[] afError = new float[1024];
  float[] dRange = new float[2];
  float[] fDist = new float[4096];
  //Compute Fourier spectrum of overlapping 1024-sample sections of the error waveform
  //***********It would be better to plot a waterfall 3-D diagram of the successive spectra
  for (int i = 0; i < 15; i++) {
    int fframe = 303+256*i;
    fError[i] = doFourier(data[2], 1024, fframe);    //Fourier transform of the error waveform
  }
  for (int i = 0; i < 1024; i++) {
    afError[i] = 0;
  }
  //Sum the sectional spectra -- visually the same as averaging, because it is scaled for display
  for (int i = 0; i < 1024; i++) {
    for (int j = 0; j < 15; j++) {
      afError[i] += fError[j][i];
    }
  }
  fRange = getRange(afError);
  float eLow = fRange[1] - 2;    // keep top 2 log units (40 dB)
  float fsc = 200/(fRange[1]-eLow);
  for (int i = 0; i<1024; i++) {
    afError[i] = max(eLow, afError[i]);
  }

  fDist = doFourier(data[0], 4096, 303);
  dRange = getRange(fDist);
  float dLow = dRange[1] - 2;         //Keep top 40 db (1 log unit amplitude = 20 db)
  float dsc = 200/(dRange[1] - dLow);
  for (int i = 0; i<1024; i++) {     
    fDist[i] = max(dLow, fDist[i]);
  }

  //Plot averaged Fourier error spectrum and disturbance spectrum
  dataGraph f = new dataGraph(600, 375, 400, 200, #226666);
  f.grBackground();         //Make sure background is displayed before annotations
  f.grxDivisions(28, 10, "Frequency 0.1 Hz", false);
  f.gryDivisions(10, 5, "10db Major Intervals", true, -20, #eeeeee);
  f.grTitle("Fourier Analysis of Error Signal", 16, 380, 25, #ff66ff, RIGHT);
  f.graphData(afError, 25, 0, #ff66ff, fsc, eLow);
  f.grTitle("of Disturbance)", 16, 380, 45, #EE3333, RIGHT);
  f.graphData(fDist, 100, 0, #EE3333, dsc, dLow);

  //Some general statistics

  stage = 6;
}

void stage_6() {
  // Create a file name and save the data in that file 
  String[] lines = new String[4099];
  lines[0] = ("speed, separation, rms_targ, rms_curs, rms_Vmodel, rms_error, rms_Vmodel-fit, rms_Vmodel-err-mismatch, gain, leak, lag, tolerance");
  lines[2] = ("target, cursor, hum_err, separation, Angle,  Vmodel, Vmodel_err,  Vmodel_mismatch, Vmodel errorDiff, Amodel, Amodel_err, Amodel_mismatch, Amodel errorDiff");
  for (int j = runin; j< (4096+runin); j++) {
    int i = j-runin;
    lines[i+3] = data[0][i]+", "+data[1][i]+", "+data[2][i]+", "+data[3][i]+", "+data[4][i]+", "+data[5][i];
  }
  rms_t = doRMS(data[0], 4396, 303);
  rms_c = doRMS(data[1], 4396, 303);
  rms_e = doRMS(data[2], 4396, 303);
  rms_a = doRMS(data[4], 4396, 303);
  float cr = rms_t/rms_e;
  gr.grResults(#33ccff, "Control Ratio = "+cr, 1, 250);
  int  ival = round(sVal);
  int iSep = round(sep);
  lines[1] =ival+", Sep"+iSep+", "+ rms_t+", "+rms_c+", "+0+", "+rms_e+", "+rms_a;
  //create a file name
  String dTs = "Nil";
  switch (dType) {
  case 0:
    dTs = "Sin";
    break;
  case 1:
    dTs = "Rmp";
    break;
  case 2:
    dTs = "Vtr";
    break;
  case 3:
    dTs = "RSt";
    break;
  case 4:
    dTs = "Tri";
    break;
  case 5:
    dTs = "Prl";
    break;
  case 6:
    dTs = "SSt";
    break;
  case 7:
    dTs = "Wit";
    break;
  default:
    println ("Unknown disturbance type "+dType);
  }

  if (newRun == true) {
    String bb = "";
    String bv = "";
    if(dTs == "Wit") {
      int topc = dN.getnWaves()+lcy;
      dTs = dTs +lcy+"-"+topc;
    }
    myFileBase = "Sp"+ival+"Sep"+iSep+"Lag"+actLag*100/6+dTs+"_"+tType+"_";
    if (slBlank > 0) {
      if (isBlanking == true) {
        bb = "Bl";
      }
      if (isBursting == true) {
        bb = "Bu";
      }
      if (bbIsVariable == true) {
        bv = "var";
      }
      myFileBase = myFileBase+bb+bv+slVar+"_"+slVis+"-"+slBlank+"_";
    }
    //Check whether the file exists, and incremenet the serial number if it does
    for (int i = 1; i < 11; i++) {
      myFile = dataFolderR+myFileBase+i+".csv";
      //    println ("trying myFile = "+myFile);
      f = dataFile(myFile);
      //    println("Looking for file "+f);
      if (f.exists() == false) {
        //      println("Did not find "+myFile);
        break;
      }
      if (i == 10) {
        println ("There are already ten of these");
        //but go ahead and overwrite it anyway
      }
    }
    pushStyle();
    fill(#eeee00);
    textSize(16);
    text(myFile, 10, 30);   //Display file name with graphs
    popStyle();
  }

  //  println ("dataFolderW = " + dataFolderW);
  saveStrings(dataFolderW + myFile, lines);

  // Here we must give the option to model this run, rather than going back
  //to set up a new run
  print(".");
  cursor();
  save(dataFolderW+myFile+".jpg");

  stage = 7;
}


void stage_7() {
  if (mousePressed == true) {
    background(156);
    if (modelData == false) {
      goButton.setOff();
      goButton.setVisible(true);
      stage = 1;
    }
  }
}


//******************************************************************************
//**********              ***************             *****************
//************Supporting routines***********************************************

void drawTarget() {
  fill (200, 30, 150);
  ellipse (targ_h, targ_v, targ_w, targ_t);
}

void drawCursor() {
  fill (50, 160, 20);
  ellipse (curs_h, curs_v, curs_w, curs_t);
}

void checkMouseEdge() {
  if (mouseX < width/10 || mouseX > 9*width/10 || mouseY < height/10 || mouseY > 9*height/10) {
    cursor();
    pushStyle();
    fill(255);
    rect(mouseX-20, mouseY-20, 40, 40, 10);
    popStyle();
  }  
  else {
    noCursor();
  }
}

void tracking(char t) {
  char type = t;
  float dist;
  int mouseXlag;
  int cp;
  int m = mCount % mxBuf.length;     //pointer into mBuf now
  int mx = (m+mxBuf.length-actLag) % mxBuf.length;    // pointer into mBuf after lag time
  mxBuf[m] = mouseX;
  if (mCount == 0) {
    mInit = mouseX;
  }
  if (mCount < actLag) {
    mouseXlag = mInit;
  }
  else {
    mouseXlag = mxBuf[mx];
  }
  mCount++;
  noCursor();
  // If we are doing a bursty run, we should make sure we have a static peiod with no jumps at the ends
  // This means holding the distF index constant during the static periods and then letting it increment
  int dIndex;
  dIndex = frameCount-fstart;

  if (isBursting == false) {                 //index  continues during blanking periods
    tFrame= dIndex;
  } 
  else {
    if (slBlank == 0) {             //If the static periods are zero length
      tFrame=dIndex;
    } 
    else {                        // bbVal = 2, and we need to hold the index during static periods
      if (dIndex%blankingPeriod < tVisTime) {  //That means we incremement tFrame ony in visible periods
        tFrame++;
        cursorBlank = 1;
      }
      else {
        cursorBlank = 0;
      }
    }
  }
  dist = 0.3*width*distF[tFrame];       //distF is float with range -1 to +1
  // Compute sdif, to widen and narrow the target-cursor separation using Perlin noise
  sdif = round(sepRange*(noise(frameCount*perlinRate)));
  targ_v = height/2 - (lat/2+sdif) - round(curs_t + targ_t)/2;
  curs_v = height - targ_v;
  cp = 1;
  switch (type) {
  case 'p':                              //pursuit
    targ_h = round(dist + 0.5*width);
    curs_h = mouseXlag;
    cp = 1;
    break;
  case 'c':                             //compensatory
    curs_h = round(dist + 0.5*width + mouseXlag - targ_h);
    cp = -1;
    break;
  default:
    println ("Tracking type is "+type);
    break;
  }
  if (recording == true) {
    int i = frameCount - frecStart;  
    data[0][i] = round(dist);
    data[1][i] = (mouseXlag-tOffset)*cp;
    data[2][i] = curs_h - targ_h;
    data[3][i] = curs_v-targ_v;
    if (abs(data[3][i])>0) {
      data[4][i] = round(1000*atan(((float)data[2][i])/((float)data[3][i])));   //Angle in milliradians
    } 
    else {
      data[4][i] = data[4][i-1];  //If the angle is indeterminate, call it whatever it last was
      //The Separation should not start at zero
    }
    data[5][i] = cursorBlank;
  }
}

void doFile(File selection) {
  if (selection == null) {
    return;
  }
  newRun = false;
  inFile = selection.getAbsolutePath();
  println("doFile called with argument "+inFile);
  String inLines[] = loadStrings(inFile);
  //  println("There are "+inLines.length+"lines; inLines[10] = "+inLines[10]);
  for (int i = 0; i < inLines.length; i++) {
    String[] theLine = split(inLines[i], ",");
    if (i > 2) {
      for (int j = 0; j < theLine.length; j++) {
        data[j][i-3] = int(theLine[j]);
      }
    }
  }
  stage = 41;
}

void folderSelected(File selection) {
  if (selection == null || theVal == 0) {
    dataFolderR = "";
    dataFolderW = "data/";
  } 
  else {
    dataFolderR = selection.getAbsolutePath()+ "/";
    //    println ("DataFolderR = "+dataFolderR);
    dataFolderW = dataFolderR;
  }
}

void wait(int ms) {
  int mStart = millis();
  while ( (millis () - mStart) < ms) {
  }
}

float log10(float x) {
  return (log(x)*L10);
}

float[] getRange(float[] indata) {
  float [] dLimits = new float[2];
  return getRange(indata, 0, indata.length);
}

float[] getRange(float[] indata, int startpos, int ndata) {
  float dMax = -10e10;
  float dMin = 10e10;
  float [] dLimits = new float[2];
  for (int i = startpos; i < startpos+ndata; i++) {
    dMax = max(indata[i], dMax);
    dMin = min(indata[i], dMin);
  }
  dLimits[0] = dMin;
  dLimits[1] = dMax;
  return dLimits;
}

float getMean(int[] mydata, int indata, int startpos) {
  int sum, ndata, istart;
  float mean, fndata;
  sum = 0;
  ndata = indata;
  istart = startpos;
  fndata = (float)ndata;
  for (int i = istart; i<ndata+istart; i++) {
    sum += mydata[i];
  }
  mean = (float)sum/fndata;
  return mean;
}

float doRMS(int mydata[], int indata, int startpos) {
  int ndata, istart;
  float mean, sum, ssq, sdev, fndata;
  sum = 0;
  ssq = 0;
  ndata = indata;
  istart = startpos;
  fndata = (float)ndata;
  //  print("indata = "+indata+": ");
  for (int i = istart; i<ndata+istart; i++) {
    //    if (i< istart + 5) {
    //      print(mydata[i]+", ");
    //    }
    //    if (i == istart+5) {
    //      println(":::");
    //    }
    sum += mydata[i];
  }
  mean = (float)sum/fndata;
  for (int i = istart; i<ndata+istart; i++) {
    sdev = (float)mydata[i]-mean;
    ssq += sdev*sdev;
  }
  //  println ("ndata ="+ ndata+": sum="+sum+": mean="+mean+": ssq="+ssq);
  return (sqrt(ssq/fndata));
}

//Fourier routines for intgeger data
//The Fourier routine does an in-place transform, but we will return the transform in a separate buffer

float[] doFourier (int[] idata, int inumber, int istart) {
  myfft = new FFT(inumber, 60.0);
  myfft.window(FFT.HAMMING);
  // windowName = "Hamming";
  float[] fdata = new float[inumber];
  float [] rdata = new float[inumber];
  for (int i = istart; i < (istart+inumber); i++) {
    fdata[i-istart] = float(idata[i]);
  }
  myfft.forward(fdata);
  for (int i = 0; i < inumber; i++) {
    rdata[i] = log10(max(0.0001, myfft.getBand(i)));
  }
  return rdata;
}


void controlEvent(ControlEvent theEvent) {
  // DropdownList is of type ControlGroup.
  // A controlEvent will be triggered from inside the ControlGroup class.
  // therefore you need to check the originator of the Event with
  // if (theEvent.isGroup())
  // to avoid an error message thrown by controlP5.

  if (theEvent.isGroup()) {
    String theName = theEvent.getGroup().getName();
    // check if the Event was triggered from a ControlGroup
    if ( theName == "Difficulty") {
      sVal = theEvent.getGroup().getValue();
      return;
    }
    if (theName == "Separation") {
      sep = round(theEvent.getGroup().getValue());
      switch(sep) {
      case 0:
        lat = 0;
        sv = 0;
        break;
      case 1:
        lat = 20;
        sv = 0;
        break;
      case 2:
        lat = 60;
        sv = 0;
      case 3:
        lat = 160;
        sv = 0;
        break;
      case 4:
        lat = 360;
        sv = 0;
        break;
      case 5:
        lat = 800;
        sv = 0;
        break;
      case 6:
        lat = 160;
        sv = 1;
        break;
      case 7:
        lat = 160;
        sv = 2;
        break;
      case 8:
        lat = 160;
        sv = 3;
        break;
      default:
        break;
      }  
      return;
    } 
    if (theName == "Data Folder") {
      theVal = round(theEvent.getGroup().getValue());
      switch (theVal) {
      case 0:
        dataFolderR = "";
        dataFolderW = "data/";
        break;
      case 1:
        selectFolder("Choose a folder for your data", "folderSelected");
        break;
      default:
        println ("problem with folder selection");
      }
      return;
    }
    if (theName == "Disturbance Type") {
      dType = round(theEvent.getGroup().getValue());
    }
    if (theName == "Action Lag") {
      actLag = round(theEvent.getGroup().getValue());
    }
    if (theName == "Tracking Type") {
      int tVal = round(theEvent.getGroup().getValue());
      if (tVal == 0) {
        tType = 'p';
      } 
      else {
        tType = 'c';
      }
    }
    if (theName == "Blanking/Bursting") {
      bbVal = round(theEvent.getGroup().getValue());
    }
  }
  else {
    if (theEvent.isController()) {
      String theName = theEvent.getController().getName();
      //    println("event from controller : "+theEvent.getController().getValue()+" from "+theEvent.getController());
      if (theName == "Abort") {
        //        println("Got Stop button");
        minim.stop();
        exit();
      } 
      if (theName == "Go") {
        //          println("Got Go Button");
        return;
      }
    }
  }
}

